.ifndef __NES__
.define __NES__ 1

PPU_CTRL        = $2000
  VBLANK_NMI    = %10000000
  OBJ_8X8       = %00000000
  OBJ_8X16      = %00100000
  BG_0000       = %00000000
  BG_1000       = %00010000
  OBJ_0000      = %00000000
  OBJ_1000      = %00001000
  VRAM_DOWN     = %00000100
  NT_2000       = %00000000
  NT_2400       = %00000001
  NT_2800       = %00000010
  NT_2C00       = %00000011

PPU_MASK        = $2001
  TINT_B        = %10000000
  TINT_G        = %01000000
  TINT_R        = %00100000
  OBJ_OFF       = %00000000
  OBJ_CLIP      = %00010000
  OBJ_ON        = %00010100
  BG_OFF        = %00000000
  BG_CLIP       = %00001000
  BG_ON         = %00001010
  LIGHTGRAY     = %00000001

PPU_STATUS      = $2002
OAM_ADDR        = $2003
OAM_DATA        = $2004
PPU_SCROLL      = $2005
PPU_ADDR        = $2006
PPU_DATA        = $2007

APU_PL1_VOL     = $4000
APU_PL1_SWEEP   = $4001
APU_PL1_LO      = $4002
APU_PL1_HI      = $4003
APU_PL2_VOL     = $4004
APU_PL2_SWEEP   = $4005
APU_PL2_LO      = $4006
APU_PL2_HI      = $4007
APU_TRI_LINEAR  = $4008
;//nothing      = $4009
APU_TRI_LO      = $400a
APU_TRI_HI      = $400b
APU_NOISE_VOL   = $400c
;//nothing      = $400d
APU_NOISE_LO    = $400e
APU_NOISE_HI    = $400f
APU_DMC_FREQ    = $4010
APU_DMC_RAW     = $4011
APU_DMC_START   = $4012
APU_DMC_LEN     = $4013
OAM_DMA         = $4014
APU_SND_CHN     = $4015
APU_STATUS      = $4015
JOY_STROBE      = $4016
APU_FRAMECNT    = $4017

JOY_PORT_1      = $4016
JOY_PORT_2      = $4017
  BUTTON_NONE      = %00000000
  BUTTON_A         = %10000000
  BUTTON_B         = %01000000
  BUTTON_SELECT    = %00100000
  BUTTON_START     = %00010000
  BUTTON_UP        = %00001000
  BUTTON_DOWN      = %00000100
  BUTTON_LEFT      = %00000010
  BUTTON_RIGHT     = %00000001
  BUTTON_SNES_B        = %10000000
  BUTTON_SNES_Y        = %01000000
  BUTTON_SNES_SELECT   = %00100000
  BUTTON_SNES_START    = %00010000
  BUTTON_SNES_UP       = %00001000
  BUTTON_SNES_DOWN     = %00000100
  BUTTON_SNES_LEFT     = %00000010
  BUTTON_SNES_RIGHT    = %00000001
  BUTTON_SNES_A        = %10000000
  BUTTON_SNES_X        = %01000000
  BUTTON_SNES_L        = %00100000
  BUTTON_SNES_R        = %00010000

.endif
