#!/usr/bin/env python3
import sys

input_file = open(sys.argv[1], "rb")
output_file = open(sys.argv[2], "wb")
ines_header = input_file.read(0x10)
output_file.write(ines_header)

the42melody = (b'' + 
b'\x86\x00\x98\x4a\x4a\x29\x2a\x09\x80\x85\x01\xa9\x00\xf0\x0e\xea' +
b'\xb0\x04\xb0\x00\x90\x00\x90\x03\x18\x65\x00\x06\x00\x46\x01\xd0' +
b'\xee\x4a\x8d\x11\x40\xe8\xf0\x02\xf0\x00\xd0\x01\xc8\x18\x90\xd0')

while True:
    input_data = input_file.read(0x8000)
    input_data = input_data.replace(b'\xd2'*len(the42melody), the42melody)
    if len(input_data) == 0x8000:
        if input_data[0x7ff0:0x7ff2] == b'\xff\xff':
            checksum = 0xffff
            is_low_byte = True
            for c in input_data:
                if is_low_byte:
                    checksum += (c^0xff)
                else:
                    checksum += (c^0xff) << 8
                is_low_byte = not is_low_byte
            output_file.write(input_data[0x0000:0x7ff0])
            output_file.write(bytes([checksum & 0xff, (checksum >> 8) & 0xff]))
            output_file.write(input_data[0x7ff2:0x8000])
        else:
            output_file.write(input_data)
    elif len(input_data) == 0x4000:
        if input_data[0x3ff0:0x3ff2] == b'\xff\xff':
            checksum = 0xffff
            is_low_byte = True
            for c in input_data:
                if is_low_byte:
                    checksum += (c^0xff)
                else:
                    checksum += (c^0xff) << 8
                is_low_byte = not is_low_byte
            output_file.write(input_data[0x0000:0x3ff0])
            output_file.write(bytes([checksum & 0xff, (checksum >> 8) & 0xff]))
            output_file.write(input_data[0x3ff2:0x4000])
        else:
            output_file.write(input_data)
    else:
        if len(input_data) > 0:
            output_file.write(input_data)
        break;

input_file.close()
output_file.close()
